
import java.net.*;
import java.io.*;

public class SocketThread extends Thread {
    URL             proxy;
    URL             target;
    String          id;
    String          pass;
    JSY             jsy;

    Socket          socket;
    DataInputStream reader;
    PrintWriter     writer;


    public SocketThread( URL proxy, URL target, String id, String pass, JSY jsy ) {
        this.proxy   = proxy;
        this.target  = target;
        this.id      = id;
        this.pass    = pass;
        this.jsy     = jsy;
    }


    public void run() {
        Timer timer = new Timer( this, jsy.getTimeout() );
        timer.start();

        try {
            byte[] buff = new byte[ 1024 ];
            int    len;
            String tail;
            String resp;

            if ( proxy != null ) {
                socket = new Socket( proxy.getHost(),
                                     ( proxy.getPort() != -1 ) ? proxy.getPort() : 21 );
                tail = "@" + target.getHost();
            }
            else { // ... no proxy
                socket = new Socket( target.getHost(),
                                     ( target.getPort() != -1 ) ? target.getPort() : 21 );
                tail = "";
            }

            reader = new DataInputStream( socket.getInputStream() );
            writer = new PrintWriter( socket.getOutputStream(), true );

            resp = ""; len  = 1024;
            while ( len >= 1024 ) {
                if ( ( len = reader.read( buff ) ) > 0 )
                    resp += new String( buff, 0, len );
            }
            System.out.print( resp );

            // USER
            writer.println( "USER " + id + tail );
            System.out.println( "USER " + id + tail );

            resp = ""; len  = 1024;
            while ( len >= 1024 ) {
                if ( ( len = reader.read( buff ) ) > 0 )
                    resp += new String( buff, 0, len );
            }
            System.out.println( resp );

            // PASS
            writer.println( "PASS " + pass );
            System.out.println( "PASS " + pass );

            resp = ""; len  = 1024;
            while ( len >= 1024 ) {
                if ( ( len = reader.read( buff ) ) > 0 )
                    resp += new String( buff, 0, len );
            }
            System.out.println( resp );

            if ( resp.indexOf( "230" ) >= 0 )
                jsy.repArea.append( id + ":" + pass + " can login\n" );
            else
                System.out.println( "can not login with " + id + ":" + pass );

            writer.println( "QUIT" );

        }
        catch ( Exception e ) {
            System.err.println( "Exception in send : " + e );
        }

        timer.stop();
        timer = null;
        close();
    }


    public void close() {
        try {
            if ( reader != null ) { reader.close(); }
            if ( writer != null ) { writer.close(); }
            if ( socket != null ) { socket.close(); }

            super.stop();
        }
        catch ( Exception e ) {
            System.out.println( "Exception close : " + e );
        }
    }


    public String toString() {
        return( target + "/" + id + ":" + pass );
    }


}


class Timer extends Thread {
    SocketThread soth;
    int          timeout;


    public Timer( SocketThread soth, int timeout ) {
        this.soth    = soth;
        this.timeout = timeout;
    }


    public void run() {
        try {
            sleep( timeout );
        }
        catch( InterruptedException e ) {
            System.out.println( "interupted : " + e );
        }

        soth.close();
        System.out.println( "Time out at : " + soth );
        soth = null;
        stop();
    }


}
